var am_woocharts = {};
jQuery(function($) {

    if (typeof amchartsDemoControls !== 'undefined') {
        var int = setInterval(function() {
            if (AmCharts.charts.length === 0 || AmCharts.charts[1].chartCreated) {
                clearInterval(int);
                am_woocharts.initDemoControls();
            }
        }, 100)
    } else {
        amchartsDemoControls = [];
    }

});

am_woocharts.setConfigVar = function(prop, val) {
    var path = prop.split('.');
    var holder = AmCharts.charts[1];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            holder[element] = {};
        if (path.length === 0) {
            holder[element] = val;
        } else {
            holder = holder[element];
        }
    }
    AmCharts.charts[1].validateNow(false, true);
}
am_woocharts.getConfigVar = function(prop) {
    var path = prop.split('.');
    var holder = AmCharts.charts[1];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            return undefined;
        if (path.length === 0) {
            return holder[element];
        } else {
            holder = holder[element];
        }
    }
    return undefined;
}
am_woocharts.initDemoControls = function() {
    var $ = jQuery;
    var controlHolder = $('#demo-control-holder');
    $(amchartsDemoControls).each(function() {
        var control = $("<div>").addClass("demo-control col-md-4");
        control.append($("<div>").addClass("demo-control-category").html(this.category));
        var value = am_woocharts.getConfigVar(this.property);
        if (this.type == "slider") {
            control.append($("<div>").addClass("demo-control-value").html(value));
        }
        control.append($("<div>").addClass("demo-control-title").html(this.title));
        if (this.type == "slider") {
            var step = (this.max - this.min) / 100;
            if (step > 1)
                step = Math.round(step);
            if (typeof value === 'string') {
                value = Number(value.replace(/[^0-9.\-]*/g, ""));
            }
            var slider = $("<div>").data("property", this.property).data("unit", this.unit).slider({
                "min": this.min,
                "max": this.max,
                "step": step,
                "value": value,
                "slide": function(event, ui) {
                    var value = ui.value;
                    if ($(this).data("unit"))
                        value += $(this).data("unit");
                    $(this).siblings('.demo-control-value').html(value);
                    am_woocharts.setConfigVar($(this).data("property"), value);
                }
            });
            control.append(slider);
            this.control = slider;
            this.controlTrigger = "slidechange";
        } else if (this.type == "select") {
            var value = am_woocharts.getConfigVar(this.property);
            var wrapper = $("<div>").addClass("select");
            var select = $('<select>').data("property", this.property).on("change", function() {
                am_woocharts.setConfigVar($(this).data("property"), $(this).val());
            });
            wrapper.append(select);
            this.control = select;
            this.controlTrigger = "change";
            for (var i = 0; i < this.options.length; i++) {
                var opt_value = this.options[i];
                var option = $("<option>").val(opt_value).html(opt_value);
                if (value == opt_value)
                    option.attr("selected", "selected");
                select.append(option);
            }
            control.append(wrapper);
        }
        controlHolder.append(control);
    });
}
am_woocharts.reapplyControlSettings = function() {
    var $ = jQuery;
    if (AmCharts.charts.length && AmCharts.charts[1].chartRendered === true) {
        $(amchartsDemoControls).each(function() {
            if (this.type == 'slider') {
                am_woocharts.setConfigVar(this.control.data("property"), this.control.slider("value"));
            } else {
                $(this.control).trigger(this.controlTrigger);
            }
        });
    } else {
        setTimeout(am_woocharts.reapplyControlSettings, 100);
    }
};
jQuery(function($) {

    if (typeof amchartsDemoControls2 !== 'undefined') {
        var int = setInterval(function() {
            if (AmCharts.charts.length === 0 || AmCharts.charts[2].chartCreated) {
                clearInterval(int);
                am_woocharts.initDemoControls2();
            }
        }, 100)
    } else {
        amchartsDemoControls2 = [];
    }

});

am_woocharts.setConfigVar2 = function(prop, val) {
    var path = prop.split('.');
    var holder = AmCharts.charts[2];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            holder[element] = {};
        if (path.length === 0) {
            holder[element] = val;
        } else {
            holder = holder[element];
        }
    }
    AmCharts.charts[2].validateNow(false, true);
}
am_woocharts.getConfigVar2 = function(prop) {
    var path = prop.split('.');
    var holder = AmCharts.charts[2];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            return undefined;
        if (path.length === 0) {
            return holder[element];
        } else {
            holder = holder[element];
        }
    }
    return undefined;
}
am_woocharts.initDemoControls2 = function() {
    var $ = jQuery;
    var controlHolder = $('#demo-control-holder2');
    $(amchartsDemoControls2).each(function() {
        var control = $("<div>").addClass("demo-control col-md-4");
        control.append($("<div>").addClass("demo-control-category").html(this.category));
        var value = am_woocharts.getConfigVar2(this.property);
        if (this.type == "slider") {
            control.append($("<div>").addClass("demo-control-value").html(value));
        }
        control.append($("<div>").addClass("demo-control-title").html(this.title));
        if (this.type == "slider") {
            var step = (this.max - this.min) / 100;
            if (step > 1)
                step = Math.round(step);
            if (typeof value === 'string') {
                value = Number(value.replace(/[^0-9.\-]*/g, ""));
            }
            var slider = $("<div>").data("property", this.property).data("unit", this.unit).slider({
                "min": this.min,
                "max": this.max,
                "step": step,
                "value": value,
                "slide": function(event, ui) {
                    var value = ui.value;
                    if ($(this).data("unit"))
                        value += $(this).data("unit");
                    $(this).siblings('.demo-control-value').html(value);
                    am_woocharts.setConfigVar2($(this).data("property"), value);
                }
            });
            control.append(slider);
            this.control = slider;
            this.controlTrigger = "slidechange";
        } else if (this.type == "select") {
            var value = am_woocharts.getConfigVar2(this.property);
            var wrapper = $("<div>").addClass("select");
            var select = $('<select>').data("property", this.property).on("change", function() {
                am_woocharts.setConfigVar2($(this).data("property"), $(this).val());
            });
            wrapper.append(select);
            this.control = select;
            this.controlTrigger = "change";
            for (var i = 0; i < this.options.length; i++) {
                var opt_value = this.options[i];
                var option = $("<option>").val(opt_value).html(opt_value);
                if (value == opt_value)
                    option.attr("selected", "selected");
                select.append(option);
            }
            control.append(wrapper);
        }
        controlHolder.append(control);
    });
}
am_woocharts.reapplyControlSettings2 = function() {
    var $ = jQuery;
    if (AmCharts.charts.length && AmCharts.charts[2].chartRendered === true) {
        $(amchartsDemoControls2).each(function() {
            if (this.type == 'slider') {
                am_woocharts.setConfigVar(this.control.data("property"), this.control.slider("value"));
            } else {
                $(this.control).trigger(this.controlTrigger);
            }
        });
    } else {
        setTimeout(am_woocharts.reapplyControlSettings, 100);
    }
};

jQuery(function($) {

    if (typeof amchartsDemoControls3 !== 'undefined') {
        var int = setInterval(function() {
            if (AmCharts.charts.length === 0 || AmCharts.charts[3].chartCreated) {
                clearInterval(int);
                am_woocharts.initDemoControls3();
            }
        }, 100)
    } else {
        amchartsDemoControls3 = [];
    }

});

am_woocharts.setConfigVar3 = function(prop, val) {
    var path = prop.split('.');
    var holder = AmCharts.charts[3];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            holder[element] = {};
        if (path.length === 0) {
            holder[element] = val;
        } else {
            holder = holder[element];
        }
    }
    AmCharts.charts[3].validateNow(false, true);
}
am_woocharts.getConfigVar3 = function(prop) {
    var path = prop.split('.');
    var holder = AmCharts.charts[3];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            return undefined;
        if (path.length === 0) {
            return holder[element];
        } else {
            holder = holder[element];
        }
    }
    return undefined;
}
am_woocharts.initDemoControls3 = function() {
    var $ = jQuery;
    var controlHolder = $('#demo-control-holder3');
    $(amchartsDemoControls3).each(function() {
        var control = $("<div>").addClass("demo-control col-md-4");
        control.append($("<div>").addClass("demo-control-category").html(this.category));
        var value = am_woocharts.getConfigVar3(this.property);
        if (this.type == "slider") {
            control.append($("<div>").addClass("demo-control-value").html(value));
        }
        control.append($("<div>").addClass("demo-control-title").html(this.title));
        if (this.type == "slider") {
            var step = (this.max - this.min) / 100;
            if (step > 1)
                step = Math.round(step);
            if (typeof value === 'string') {
                value = Number(value.replace(/[^0-9.\-]*/g, ""));
            }
            var slider = $("<div>").data("property", this.property).data("unit", this.unit).slider({
                "min": this.min,
                "max": this.max,
                "step": step,
                "value": value,
                "slide": function(event, ui) {
                    var value = ui.value;
                    if ($(this).data("unit"))
                        value += $(this).data("unit");
                    $(this).siblings('.demo-control-value').html(value);
                    am_woocharts.setConfigVar3($(this).data("property"), value);
                }
            });
            control.append(slider);
            this.control = slider;
            this.controlTrigger = "slidechange";
        } else if (this.type == "select") {
            var value = am_woocharts.getConfigVar3(this.property);
            var wrapper = $("<div>").addClass("select");
            var select = $('<select>').data("property", this.property).on("change", function() {
                am_woocharts.setConfigVar3($(this).data("property"), $(this).val());
            });
            wrapper.append(select);
            this.control = select;
            this.controlTrigger = "change";
            for (var i = 0; i < this.options.length; i++) {
                var opt_value = this.options[i];
                var option = $("<option>").val(opt_value).html(opt_value);
                if (value == opt_value)
                    option.attr("selected", "selected");
                select.append(option);
            }
            control.append(wrapper);
        }
        controlHolder.append(control);
    });
}
am_woocharts.reapplyControlSettings3 = function() {
    var $ = jQuery;
    if (AmCharts.charts.length && AmCharts.charts[3].chartRendered === true) {
        $(amchartsDemoControls3).each(function() {
            if (this.type == 'slider') {
                am_woocharts.setConfigVar(this.control.data("property"), this.control.slider("value"));
            } else {
                $(this.control).trigger(this.controlTrigger);
            }
        });
    } else {
        setTimeout(am_woocharts.reapplyControlSettings, 100);
    }
};

jQuery(function($) {

    if (typeof amchartsDemoControls4 !== 'undefined') {
        var int = setInterval(function() {
            if (AmCharts.charts.length === 0 || AmCharts.charts[4].chartCreated) {
                clearInterval(int);
                am_woocharts.initDemoControls4();
            }
        }, 100)
    } else {
        amchartsDemoControls4 = [];
    }

});

am_woocharts.setConfigVar4 = function(prop, val) {
    var path = prop.split('.');
    var holder = AmCharts.charts[4];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            holder[element] = {};
        if (path.length === 0) {
            holder[element] = val;
        } else {
            holder = holder[element];
        }
    }
    AmCharts.charts[4].validateNow(false, true);
}
am_woocharts.getConfigVar4 = function(prop) {
    var path = prop.split('.');
    var holder = AmCharts.charts[4];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            return undefined;
        if (path.length === 0) {
            return holder[element];
        } else {
            holder = holder[element];
        }
    }
    return undefined;
}
am_woocharts.initDemoControls4 = function() {
    var $ = jQuery;
    var controlHolder = $('#demo-control-holder4');
    $(amchartsDemoControls4).each(function() {
        var control = $("<div>").addClass("demo-control col-md-4");
        control.append($("<div>").addClass("demo-control-category").html(this.category));
        var value = am_woocharts.getConfigVar4(this.property);
        if (this.type == "slider") {
            control.append($("<div>").addClass("demo-control-value").html(value));
        }
        control.append($("<div>").addClass("demo-control-title").html(this.title));
        if (this.type == "slider") {
            var step = (this.max - this.min) / 100;
            if (step > 1)
                step = Math.round(step);
            if (typeof value === 'string') {
                value = Number(value.replace(/[^0-9.\-]*/g, ""));
            }
            var slider = $("<div>").data("property", this.property).data("unit", this.unit).slider({
                "min": this.min,
                "max": this.max,
                "step": step,
                "value": value,
                "slide": function(event, ui) {
                    var value = ui.value;
                    if ($(this).data("unit"))
                        value += $(this).data("unit");
                    $(this).siblings('.demo-control-value').html(value);
                    am_woocharts.setConfigVar4($(this).data("property"), value);
                }
            });
            control.append(slider);
            this.control = slider;
            this.controlTrigger = "slidechange";
        } else if (this.type == "select") {
            var value = am_woocharts.getConfigVar4(this.property);
            var wrapper = $("<div>").addClass("select");
            var select = $('<select>').data("property", this.property).on("change", function() {
                am_woocharts.setConfigVar4($(this).data("property"), $(this).val());
            });
            wrapper.append(select);
            this.control = select;
            this.controlTrigger = "change";
            for (var i = 0; i < this.options.length; i++) {
                var opt_value = this.options[i];
                var option = $("<option>").val(opt_value).html(opt_value);
                if (value == opt_value)
                    option.attr("selected", "selected");
                select.append(option);
            }
            control.append(wrapper);
        }
        controlHolder.append(control);
    });
}
am_woocharts.reapplyControlSettings4 = function() {
    var $ = jQuery;
    if (AmCharts.charts.length && AmCharts.charts[4].chartRendered === true) {
        $(amchartsDemoControls4).each(function() {
            if (this.type == 'slider') {
                am_woocharts.setConfigVar(this.control.data("property"), this.control.slider("value"));
            } else {
                $(this.control).trigger(this.controlTrigger);
            }
        });
    } else {
        setTimeout(am_woocharts.reapplyControlSettings, 100);
    }
};

jQuery(function($) {

    if (typeof amchartsDemoControls0 !== 'undefined') {
        var int = setInterval(function() {
            if (AmCharts.charts.length === 0 || AmCharts.charts[0].chartCreated) {
                clearInterval(int);
                am_woocharts.initDemoControls0();
            }
        }, 100)
    } else {
        amchartsDemoControls0 = [];
    }

});

am_woocharts.setConfigVar0 = function(prop, val) {
    var path = prop.split('.');
    var holder = AmCharts.charts[0];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            holder[element] = {};
        if (path.length === 0) {
            holder[element] = val;
        } else {
            holder = holder[element];
        }
    }
    AmCharts.charts[0].validateNow(false, true);
}
am_woocharts.getConfigVar0 = function(prop) {
    var path = prop.split('.');
    var holder = AmCharts.charts[0];
    var element;
    while (element = path.shift()) {
        var index = element.match(/\[([0-9])*\]/);
        if (index !== null) {
            element = element.replace(/\[.*/, "");
            holder = holder[element];
            element = Number(index[1]);
        }
        if (typeof holder[element] === "undefined")
            return undefined;
        if (path.length === 0) {
            return holder[element];
        } else {
            holder = holder[element];
        }
    }
    return undefined;
}
am_woocharts.initDemoControls0 = function() {
    var $ = jQuery;
    var controlHolder = $('#demo-control-holder0');
    $(amchartsDemoControls0).each(function() {
        var control = $("<div>").addClass("demo-control col-md-4");
        control.append($("<div>").addClass("demo-control-category").html(this.category));
        var value = am_woocharts.getConfigVar0(this.property);
        if (this.type == "slider") {
            control.append($("<div>").addClass("demo-control-value").html(value));
        }
        control.append($("<div>").addClass("demo-control-title").html(this.title));
        if (this.type == "slider") {
            var step = (this.max - this.min) / 100;
            if (step > 1)
                step = Math.round(step);
            if (typeof value === 'string') {
                value = Number(value.replace(/[^0-9.\-]*/g, ""));
            }
            var slider = $("<div>").data("property", this.property).data("unit", this.unit).slider({
                "min": this.min,
                "max": this.max,
                "step": step,
                "value": value,
                "slide": function(event, ui) {
                    var value = ui.value;
                    if ($(this).data("unit"))
                        value += $(this).data("unit");
                    $(this).siblings('.demo-control-value').html(value);
                    am_woocharts.setConfigVar0($(this).data("property"), value);
                }
            });
            control.append(slider);
            this.control = slider;
            this.controlTrigger = "slidechange";
        } else if (this.type == "select") {
            var value = am_woocharts.getConfigVar0(this.property);
            var wrapper = $("<div>").addClass("select");
            var select = $('<select>').data("property", this.property).on("change", function() {
                am_woocharts.setConfigVar0($(this).data("property"), $(this).val());
            });
            wrapper.append(select);
            this.control = select;
            this.controlTrigger = "change";
            for (var i = 0; i < this.options.length; i++) {
                var opt_value = this.options[i];
                var option = $("<option>").val(opt_value).html(opt_value);
                if (value == opt_value)
                    option.attr("selected", "selected");
                select.append(option);
            }
            control.append(wrapper);
        }
        controlHolder.append(control);
    });
}
am_woocharts.reapplyControlSettings0 = function() {
    var $ = jQuery;
    if (AmCharts.charts.length && AmCharts.charts[0].chartRendered === true) {
        $(amchartsDemoControls0).each(function() {
            if (this.type == 'slider') {
                am_woocharts.setConfigVar(this.control.data("property"), this.control.slider("value"));
            } else {
                $(this.control).trigger(this.controlTrigger);
            }
        });
    } else {
        setTimeout(am_woocharts.reapplyControlSettings, 100);
    }
};