<?php

function wcesp_get_total_sales($sec)
{
   global $wpdb;
   $today = date("Y-m-d");
   if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }

   $data              = array();
   $range =  sanitize_title($_GET['range']);
   $query_total_sales = "SELECT order_item_meta_2.meta_value as product_id, ROUND(SUM( order_item_meta.meta_value ),2) as line_total,order_items.order_item_name as Product_name FROM {$wpdb->prefix}woocommerce_order_items as order_items 
     
       LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON order_items.order_item_id = order_item_meta.order_item_id 
       LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta_2 ON order_items.order_item_id = order_item_meta_2.order_item_id 
       LEFT JOIN {$wpdb->prefix}posts AS posts ON order_items.order_id = posts.ID"; 

       if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != ''){

        $query_total_sales .="
       INNER JOIN {$wpdb->prefix}postmeta as country_filter ON posts.ID = country_filter.post_id 

       
     
       WHERE   posts.post_type   = 'shop_order' 
       AND   posts.post_status   = 'wc-completed' 
       AND   order_items.order_item_type = 'line_item' 
       AND   order_item_meta.meta_key = '_line_total' 
       AND   order_item_meta_2.meta_key = '_product_id' AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}' ";
       }

       else {

          $query_total_sales .="
      
     
       WHERE   posts.post_type   = 'shop_order' 
       AND   posts.post_status   = 'wc-completed' 
       AND   order_items.order_item_type = 'line_item' 
       AND   order_item_meta.meta_key = '_line_total' 
       AND   order_item_meta_2.meta_key = '_product_id' ";

       }
      
   switch ($range) {
      case "custom":
         $query_total_sales .= " AND  date_format(posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY order_item_meta_2.meta_value ORDER BY line_total DESC LIMIT 10";
         break;
      default:
         $query_total_sales .= " AND  date_format(posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY order_item_meta_2.meta_value ORDER BY line_total DESC LIMIT 10";
   }
   $mylink = $wpdb->get_results($query_total_sales);
     if($_GET['product_filter'] && $_GET['product_filter'] != 'all'){

    $pid = sanitize_title($_GET['product_filter']);
    foreach ($mylink as $key => $r) {
      $id                = $r->product_id;
      $product_name      = $wpdb->get_var("SELECT post_title FROM {$wpdb->prefix}posts WHERE ID =  $id");
      $total             = number_format((float) $r->line_total, 2, '.', '');
      if($pid != 0){

        if($id == $pid){
          $data[] = $r;
        
        }
      }
      
      
     
   }

   }
   else {

   foreach ($mylink as $key => $r) {
      $id                = $r->product_id;
      $product_name      = $wpdb->get_var("SELECT post_title FROM {$wpdb->prefix}posts WHERE ID =  $id");
      $total             = number_format((float) $r->line_total, 2, '.', '');
      
      
      $data[] = $r;
   }

   }
   return $data;


}

function wcesp_get_order_status($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data               = array();
   $range =  sanitize_title($_GET['range']);
   //Query to get status count of orders
   if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {

$query_order_status = "SELECT REPLACE(post_status,'wc-','') AS status,COUNT(*) AS count, post_date 
FROM {$wpdb->prefix}posts
INNER JOIN {$wpdb->prefix}postmeta AS country_filter ON {$wpdb->prefix}posts.ID = country_filter.post_id
WHERE 1=1 
AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value='{$_GET['country']}'
 ";

   }

   else {

    $query_order_status = "SELECT REPLACE(post_status,'wc-','') AS status,COUNT(*) AS count, post_date FROM {$wpdb->prefix}posts WHERE 1=1 ";
   }
   
  
   switch ($range) {
      case "custom":
         $query_order_status .= " AND  date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' AND post_type = 'shop_order' GROUP BY post_status HAVING post_status = 'wc-completed' OR post_status = 'wc-pending' OR post_status = 'wc-processing' OR post_status = 'wc-on-hold' OR post_status = 'wc-cancelled' OR post_status = 'wc-refunded' OR post_status = 'wc-failed' ORDER BY count DESC ";
         break;
      default:
         $query_order_status .= " AND  date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' AND post_type = 'shop_order' GROUP BY post_status HAVING post_status = 'wc-completed' OR post_status = 'wc-pending' OR post_status = 'wc-processing' OR post_status = 'wc-on-hold' OR post_status = 'wc-cancelled' OR post_status = 'wc-refunded' OR post_status = 'wc-failed' ORDER BY count DESC ";
   }
   $completed_count = 0;
   foreach ($wpdb->get_results($query_order_status) as $key => $row) {
      $status           = preg_replace('/wc-/', '', $row->status);
      $data[] = $row;
     
   }
   
   return $data;

   
}

function wcesp_get_order_count($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
   //Query to get order count of each product
    if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != ''){

        $query_product_order_count = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count_order FROM {$wpdb->prefix}posts

           INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id
           INNER JOIN {$wpdb->prefix}postmeta as country_filter ON {$wpdb->prefix}posts.ID = country_filter.post_id

         WHERE {$wpdb->prefix}posts.post_type = 'shop_order' AND {$wpdb->prefix}posts.post_status = 'wc-completed' AND {$wpdb->prefix}woocommerce_order_items.order_item_type = 'line_item' AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}' ";

    }

    else {


$query_product_order_count = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count_order FROM {$wpdb->prefix}posts   INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id WHERE {$wpdb->prefix}posts.post_type = 'shop_order' AND {$wpdb->prefix}posts.post_status = 'wc-completed' AND {$wpdb->prefix}woocommerce_order_items.order_item_type = 'line_item' ";

    }
   


   

   switch ($range) {
      case "custom":
         $query_product_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}'    ";
         break;
      default:
         $query_product_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}'";
   }

   switch ($pid) {
      case "0":
         $query_product_order_count .= "GROUP BY {$wpdb->prefix}woocommerce_order_items.order_item_name ORDER BY count_order DESC LIMIT 10 ";
         break;
         case "all":
         $query_product_order_count .= "GROUP BY {$wpdb->prefix}woocommerce_order_items.order_item_name ORDER BY count_order DESC LIMIT 10";
         break;
      default:
         $query_product_order_count .= "GROUP BY {$wpdb->prefix}woocommerce_order_items.order_item_name ORDER BY count_order DESC LIMIT 10";
   }

   $total_orders = 0;
if(($_GET['product_filter'] && $_GET['product_filter'] != '0' && $_GET['product_filter'] != 'all')){
   
      foreach ($wpdb->get_results($query_product_order_count) as $key => $row) {

        $product_name      = $wpdb->get_var("SELECT post_title FROM {$wpdb->prefix}posts WHERE ID =  $pid");
      if($row->Product == $product_name){
           $data[] = $row;
     


      }
     
   }

   }
   else {

        foreach ($wpdb->get_results($query_product_order_count) as $key => $row) {
         
      // each column in your row will be accessible like this
      $data[] = $row;
    
      
   }

   }

   return $data;
   
}

function wcesp_get_order_status_product($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
   //Query to get order count of each product
    if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != ''){


         $query_product_order_count = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count,REPLACE({$wpdb->prefix}posts.post_status,'wc-','') AS status FROM {$wpdb->prefix}posts
            INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id 
            INNER JOIN {$wpdb->prefix}postmeta AS country_filter ON {$wpdb->prefix}posts.ID = country_filter.post_id 
            WHERE {$wpdb->prefix}posts.post_type = 'shop_order' AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}' ";

    }
    else {

       $query_product_order_count = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count,REPLACE({$wpdb->prefix}posts.post_status,'wc-','') AS status FROM {$wpdb->prefix}posts   INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id WHERE {$wpdb->prefix}posts.post_type = 'shop_order' ";
    }
  
  

   switch ($range) {
      case "custom":
         $query_product_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}'    ";
         break;
      default:
         $query_product_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}'";
   }

   switch ($pid) {
      case "0":
         $query_product_order_count .= "GROUP BY {$wpdb->prefix}woocommerce_order_items.order_item_name ORDER BY count DESC";
         break;
      default:
         $query_product_order_count .= "GROUP BY Product,status";
   }

   $total_orders = 0;
if($_GET['product_filter'] && $_GET['product_filter'] != '0'){
   
      foreach ($wpdb->get_results($query_product_order_count) as $key => $row) {

        $product_name      = $wpdb->get_var("SELECT post_title FROM {$wpdb->prefix}posts WHERE ID =  $pid");
      if($row->Product == $product_name){
           
      $status           = preg_replace('/wc-/', '', $row->status);
      $data[] = $row;
      


      }
     
   }

   }
  
   return $data;
   
}

function wcesp_get_sales_country_product($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
   //Query to get order count of each product
    if(!$_GET['country'] || $_GET['country'] == '' || $_GET['country'] == 'all') {

        $query_product_order_count_country = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,order_country.meta_value AS country
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
              JOIN {$wpdb->prefix}postmeta as order_country ON order_country.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_country.meta_key = '_billing_country'

             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}'  ";
    }

    else {

      $query_product_order_count_country = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,order_country.meta_value AS country
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
              JOIN {$wpdb->prefix}postmeta as order_country ON order_country.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_country.meta_key = '_billing_country'
             AND order_country.meta_value = '{$_GET['country']}'
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}'  ";
    }
   
    

   switch ($range) {
      case "custom":
         $query_product_order_count_country .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY country ORDER BY total_sales DESC LIMIT 10   ";
         break;
      default:
         $query_product_order_count_country .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY country ORDER BY total_sales DESC LIMIT 10 ";
   }


  

   
      foreach ($wpdb->get_results($query_product_order_count_country) as $key => $row) {

        $data[] = $row;

     
   }

   

   return $data;
   
}

function wcesp_get_country_sales($sec)
{
   
   
   global $wpdb;
   $today = date("Y-m-d");
     if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }


   $data                      = array();
   $range =  sanitize_title($_GET['range']);
   //Query to get sales count from each countries
   $cdata                     = array();
   if(!$_GET['country'] || $_GET['country'] == '' || $_GET['country'] == 'all') {

 $query_country_order_count = "SELECT 
             ROUND(SUM(order_total.meta_value),2)as 'total_sales' 
             ,COUNT(*)as 'order_count' 
             ,billing_country.meta_value as country 
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID  
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_country ON billing_country.post_id={$wpdb->prefix}posts.ID   
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_total.meta_key='_order_total'  
             AND billing_country.meta_key='_billing_country' AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";


   }

   else {

     $query_country_order_count = "SELECT 
             ROUND(SUM(order_total.meta_value),2)as 'total_sales' 
             ,COUNT(*)as 'order_count' 
             ,billing_country.meta_value as country 
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID  
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_country ON billing_country.post_id={$wpdb->prefix}posts.ID   
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_total.meta_key='_order_total'  
             AND billing_country.meta_key='_billing_country' AND billing_country.meta_value = '{$_GET['country']}' AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";


   }
  
   switch ($range) {
      case "custom":
         $query_country_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY  country ORDER BY total_sales DESC LIMIT 10  ";
         break;
      default:
         $query_country_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY country ORDER BY total_sales DESC LIMIT 10";
   }
   foreach ($wpdb->get_results($query_country_order_count) as $key => $row) {
      // each column in your row will be accessible like this
      // $cdata[] = array('label' => $row->billing_country, 'value' => number_format((float) $row->order_total, 2, '.', ''));
      $data[] = $row;
      
      
   }
   
   return $data;
   
}

function wcesp_get_state_sales($sec)
{
   
   
   global $wpdb;
   $today = date("Y-m-d");
     if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data                      = array();
   $range =  sanitize_title($_GET['range']);
   $country = sanitize_title($_GET['country']);
   //Query to get sales count from each countries
   $cdata                     = array();
   if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != ''){


              $query_states_order_count = "SELECT 
             ROUND(SUM(order_total.meta_value),2)as 'total_sales' 
             ,COUNT(*)as 'order_count' 
             ,billing_state.meta_value as states
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID  
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_country ON billing_country.post_id={$wpdb->prefix}posts.ID 
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_state ON billing_state.post_id={$wpdb->prefix}posts.ID  
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_total.meta_key='_order_total'  
             AND billing_country.meta_key='_billing_country'
             AND billing_country.meta_value='{$country}' 
             AND billing_state.meta_key='_billing_state'
              AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";
   }

   else{



     $query_states_order_count = "SELECT 
             ROUND(SUM(order_total.meta_value),2)as 'total_sales' 
             ,COUNT(*)as 'order_count' 
             ,billing_state.meta_value as states
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID  
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_country ON billing_country.post_id={$wpdb->prefix}posts.ID 
             LEFT JOIN  {$wpdb->prefix}postmeta as billing_state ON billing_state.post_id={$wpdb->prefix}posts.ID  
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_total.meta_key='_order_total'  
             AND billing_country.meta_key='_billing_country'
             AND billing_state.meta_key='_billing_state'
              AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";

   
   

            }
   switch ($range) {
      case "custom":
         $query_states_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY  states ORDER BY total_sales DESC LIMIT 10  ";
         break;
      default:
         $query_states_order_count .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY  states ORDER BY total_sales DESC LIMIT 10";
   }
   foreach ($wpdb->get_results($query_states_order_count) as $key => $row) {
      // each column in your row will be accessible like this
      // $cdata[] = array('label' => $row->billing_country, 'value' => number_format((float) $row->order_total, 2, '.', ''));
      $data[] = $row;
      
      
   }
   
   return $data;
   
}

function wcesp_get_sales_states_product($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
    $country = sanitize_title($_GET['country']);
   
        if($_GET['country'] && $_GET['country'] != 'all'){

             $query_product_order_count_states = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,order_state.meta_value AS states
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
              JOIN {$wpdb->prefix}postmeta as order_country ON order_country.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}postmeta as order_state ON order_state.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_country.meta_key = '_billing_country'
             AND order_country.meta_value = '{$country}'
             AND order_state.meta_key = '_billing_state'
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}'  ";

        }

else {

 $query_product_order_count_states = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,order_state.meta_value AS states
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
              JOIN {$wpdb->prefix}postmeta as order_country ON order_country.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}postmeta as order_state ON order_state.post_id={$wpdb->prefix}posts.ID 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_country.meta_key = '_billing_country'
             AND order_state.meta_key = '_billing_state'
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}'  ";

}
  
    

   switch ($range) {
      case "custom":
         $query_product_order_count_states .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY states ORDER BY total_sales DESC LIMIT 10   ";
         break;
      default:
         $query_product_order_count_states .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY states ORDER BY total_sales DESC LIMIT 10 ";
   }


  

   
      foreach ($wpdb->get_results($query_product_order_count_states) as $key => $row) {

        $data[] = $row;

     
   }

   

   return $data;
   
}

function wcesp_get_sales_by_date($sec)
{
   
   global $wpdb;
  $today = date("Y-m-d");
   if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data                = array();
   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
    
   
   //Query to get sales by date

    if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {

$query_sales_per_day = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,oord.order_item_id
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              INNER JOIN {$wpdb->prefix}postmeta as country_filter ON {$wpdb->prefix}posts.ID = country_filter.post_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' 
             AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}' 
              ";

    }

    else {

      $query_sales_per_day = "SELECT 
             ROUND(SUM(order_item_meta.meta_value),2) as 'total_sales',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as dates,oord.order_item_id
             FROM  {$wpdb->prefix}posts     
             
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id 
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id'  
              ";
    }
   
             if($pid != 0) {

                $query_sales_per_day .= " AND order_item_meta2.meta_value ='{$pid}'";

             }
   switch ($range) {
      case "custom":
         $query_sales_per_day .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY dates ORDER BY dates ASC";
         break;
      default:
         $query_sales_per_day .= "AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY dates ORDER BY dates ASC";
   }
   
   foreach ($wpdb->get_results($query_sales_per_day) as $key => $row) {
      // each column in your row will be accessible like this
      $data[] = $row;
      
      
   }
   
   return $data;
   
}


function wcesp_get_payment_method($sec)
{
   
   
   global $wpdb;
   $today = date("Y-m-d");
     if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data                      = array();
   $range =  sanitize_title($_GET['range']);
   $country = sanitize_title($_GET['country']);
   //Query to get sales count from each countries
   $cdata                     = array();
  


if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {



     $query_payment = "SELECT 
             order_info.meta_value as 'payment' 
             ,COUNT(*)as 'order_count' 
         
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_info ON order_info.post_id={$wpdb->prefix}posts.ID
             LEFT JOIN  {$wpdb->prefix}postmeta as country_filter ON country_filter.post_id={$wpdb->prefix}posts.ID
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_info.meta_key='_payment_method_title'
             AND country_filter.meta_key = '_billing_country' 
             AND country_filter.meta_value = '{$_GET['country']}'  
              AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";
}

else {


   $query_payment = "SELECT 
             order_info.meta_value as 'payment' 
             ,COUNT(*)as 'order_count' 
         
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_info ON order_info.post_id={$wpdb->prefix}posts.ID
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
             AND order_info.meta_key='_payment_method_title'  
              AND {$wpdb->prefix}posts.post_status IN ('wc-completed') ";
}
    

   switch ($range) {
      case "custom":
         $query_payment .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY  payment ORDER BY order_count DESC LIMIT 10  ";
         break;
      default:
         $query_payment .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY  payment ORDER BY order_count DESC LIMIT 10";
   }
   foreach ($wpdb->get_results($query_payment) as $key => $row) {
      // each column in your row will be accessible like this
      // $cdata[] = array('label' => $row->billing_country, 'value' => number_format((float) $row->order_total, 2, '.', ''));
      $data[] = $row;
      
      
   }
   
   return $data;
   
}


function wcesp_get_payment_method_product($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);
    $pid = sanitize_title($_GET['product_filter']);
    $country = sanitize_title($_GET['country']);
   
if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {


       $query_payment_product = "SELECT 
             order_info.meta_value as 'payment' 
             ,COUNT(*)as 'order_count' 
         
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_info ON order_info.post_id={$wpdb->prefix}posts.ID
             INNER JOIN  {$wpdb->prefix}postmeta as country_filter ON {$wpdb->prefix}posts.ID=country_filter.post_id
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
             
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
            AND order_info.meta_key='_payment_method_title' 
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}' 
             AND country_filter.meta_key='_billing_country' AND country_filter.meta_value = '{$_GET['country']}' ";

}

else {

 $query_payment_product = "SELECT 
             order_info.meta_value as 'payment' 
             ,COUNT(*)as 'order_count' 
         
             FROM {$wpdb->prefix}posts   
             LEFT JOIN  {$wpdb->prefix}postmeta as order_info ON order_info.post_id={$wpdb->prefix}posts.ID
              JOIN {$wpdb->prefix}woocommerce_order_items as oord ON {$wpdb->prefix}posts.ID = oord.order_id
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON oord.order_item_id = order_item_meta.order_item_id
             
              JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta2 ON oord.order_item_id = order_item_meta2.order_item_id 
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order'  
            AND order_info.meta_key='_payment_method_title' 
             AND order_item_meta.meta_key='_line_total' AND {$wpdb->prefix}posts.post_status IN ('wc-completed')
             AND order_item_meta2.meta_key = '_product_id' AND order_item_meta2.meta_value ='{$pid}'  ";

}


  
    

   switch ($range) {
      case "custom":
         $query_payment_product .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY payment ORDER BY order_count DESC LIMIT 10   ";
         break;
      default:
         $query_payment_product .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY payment ORDER BY order_count DESC LIMIT 10 ";
   }


  

   
      foreach ($wpdb->get_results($query_payment_product) as $key => $row) {

        $data[] = $row;

     
   }

   

   return $data;
   
}


function wcesp_get_category_order($sec)
{
   
   global $wpdb;
   $today = date("Y-m-d");
    if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data = array();

   $range =  sanitize_title($_GET['range']);

   if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {



     $query_category_order = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count_order,oord.meta_value as PID,cat.term_taxonomy_id as catid,catn.name as catname 
FROM {$wpdb->prefix}posts  
INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id
INNER JOIN {$wpdb->prefix}postmeta AS country_filter ON {$wpdb->prefix}posts.ID = country_filter.post_id
JOIN {$wpdb->prefix}woocommerce_order_itemmeta as oord ON  {$wpdb->prefix}woocommerce_order_items.order_item_id = oord.order_item_id
JOIN {$wpdb->prefix}term_relationships as cat ON  oord.meta_value = cat.object_id
JOIN {$wpdb->prefix}terms as catn ON  cat.term_taxonomy_id = catn.term_id
LEFT JOIN {$wpdb->prefix}term_taxonomy as catnn ON cat.term_taxonomy_id = catnn.term_taxonomy_id
WHERE {$wpdb->prefix}posts.post_type = 'shop_order' 
AND {$wpdb->prefix}posts.post_status = 'wc-completed' 
AND oord.meta_key = '_product_id'
AND oord.meta_value IN(SELECT object_id FROM {$wpdb->prefix}term_relationships WHERE term_taxonomy_id IN(SELECT term_taxonomy_id  FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy = 'product_cat')) 
AND cat.term_taxonomy_id > 2 
AND country_filter.meta_key = '_billing_country' AND country_filter.meta_key = '{$_GET['country']}' AND catnn.taxonomy = 'product_cat' ";


   }

   else {

 $query_category_order = "SELECT {$wpdb->prefix}posts.ID,{$wpdb->prefix}woocommerce_order_items.order_id,{$wpdb->prefix}woocommerce_order_items.order_item_name as Product,COUNT(*) AS count_order,oord.meta_value as PID,cat.term_taxonomy_id as catid,catn.name as catname 
FROM {$wpdb->prefix}posts  
INNER JOIN {$wpdb->prefix}woocommerce_order_items ON {$wpdb->prefix}posts.ID = {$wpdb->prefix}woocommerce_order_items.order_id
JOIN {$wpdb->prefix}woocommerce_order_itemmeta as oord ON  {$wpdb->prefix}woocommerce_order_items.order_item_id = oord.order_item_id
JOIN {$wpdb->prefix}term_relationships as cat ON  oord.meta_value = cat.object_id
JOIN {$wpdb->prefix}terms as catn ON  cat.term_taxonomy_id = catn.term_id
LEFT JOIN {$wpdb->prefix}term_taxonomy as catnn ON cat.term_taxonomy_id = catnn.term_taxonomy_id
WHERE {$wpdb->prefix}posts.post_type = 'shop_order' 
AND {$wpdb->prefix}posts.post_status = 'wc-completed' 
AND oord.meta_key = '_product_id'
 AND catnn.taxonomy = 'product_cat'
AND oord.meta_value IN(SELECT object_id FROM {$wpdb->prefix}term_relationships WHERE term_taxonomy_id IN(SELECT term_taxonomy_id  FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy = 'product_cat')) 
AND cat.term_taxonomy_id > 2";



   }
   
  
  

   switch ($range) {
      case "custom":
         $query_category_order .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY catname ORDER BY count_order DESC ";
         break;
      default:
         $query_category_order .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY catname ORDER BY count_order DESC";
   }


   

        foreach ($wpdb->get_results($query_category_order) as $key => $row) {
         
      // each column in your row will be accessible like this
      $data[] = $row;
    
      
   }


   return $data;
   
}


function wcesp_get_refunds($sec)
{
   
   
   
   global $wpdb;
   $today = date("Y-m-d");
   if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    if($sec == 1){

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    }
    else {
      $start_date =  $today;
      $end_date   =  $today;

    }
   }

   else {

     $start_date =  $today;
      $end_date   =  $today;
   }
   $data                  = array();
   $range =  sanitize_title($_GET['range']);
   $pid = sanitize_title($_GET['product_filter']);
   if(!$pid || $pid == 0 || $pid == ''){

if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {

 $query_refunds_per_day = "SELECT 
             SUM(order_total.meta_value)as 'total_refunds',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as refund_dates 
             FROM  {$wpdb->prefix}posts     
             LEFT JOIN   {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID
             INNER JOIN   {$wpdb->prefix}postmeta as country_filter ON country_filter.post_id={$wpdb->prefix}posts.ID  
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order_refund'  
             AND order_total.meta_key='_order_total'
             AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}'
             ";
}
   
   else {

      $query_refunds_per_day = "SELECT 
             SUM(order_total.meta_value)as 'total_refunds',date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') as refund_dates 
             FROM  {$wpdb->prefix}posts     
             LEFT JOIN   {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID  
             
             WHERE 1=1 
             AND {$wpdb->prefix}posts.post_type ='shop_order_refund'  
             AND order_total.meta_key='_order_total'";
   }

   
  
          }

          if($pid !=0){

                if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != '') {

                  $query_refunds_per_day = "SELECT 
             SUM(order_total.meta_value)as 'total_refunds',order_product.meta_value as product
             FROM  {$wpdb->prefix}posts     
             LEFT JOIN   {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID
             LEFT JOIN   {$wpdb->prefix}postmeta as country_filter ON country_filter.post_id={$wpdb->prefix}posts.ID
             INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_product ON {$wpdb->prefix}posts.ID = order_product.order_item_id  
            
             AND {$wpdb->prefix}posts.post_type ='shop_order_refund'  
             AND order_total.meta_key='_refund_amount'
             AND order_product.meta_key = '_product_id'
             AND order_product.meta_value = '{$pid}'
             AND country_filter.meta_key = '_billing_country' AND country_filter = '{$_GET['country']}' ";
                }

                else {

                  $query_refunds_per_day = "SELECT 
             SUM(order_total.meta_value)as 'total_refunds',order_product.meta_value as product
             FROM  {$wpdb->prefix}posts     
             LEFT JOIN   {$wpdb->prefix}postmeta as order_total ON order_total.post_id={$wpdb->prefix}posts.ID
            
             INNER JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS order_product ON {$wpdb->prefix}posts.ID = order_product.order_item_id  
            
             AND {$wpdb->prefix}posts.post_type ='shop_order_refund'  
             AND order_total.meta_key='_refund_amount'
             AND order_product.meta_key = '_product_id'
             AND order_product.meta_value = '{$pid}' ";
                }
            
            

          }
   switch ($range) {
      case "custom":
         $query_refunds_per_day .= " AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}'";
         break;
      default:
         $query_refunds_per_day .= "AND date_format({$wpdb->prefix}posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' ";
   }
   $gross_refunds = 0;
   foreach ($wpdb->get_results($query_refunds_per_day) as $key => $row) {
      // each column in your row will be accessible like this
      $data['total_refunds'][]    = number_format((float) $row->total_refunds, 2, '.', '');
      $date1                      = date("M jS", strtotime("$row->refund_dates"));
      $data['refund_dates_new'][] = $date1;
      $gross_refunds -= number_format((float) $row->total_refunds, 2, '.', '');
   }
   
   return $data;
}


     

function countryCodeToName($code) {
    switch ($code) {
        case 'AF': return 'Afghanistan';
        case 'AX': return 'Aland Islands';
        case 'AL': return 'Albania';
        case 'DZ': return 'Algeria';
        case 'AS': return 'American Samoa';
        case 'AD': return 'Andorra';
        case 'AO': return 'Angola';
        case 'AI': return 'Anguilla';
        case 'AQ': return 'Antarctica';
        case 'AG': return 'Antigua and Barbuda';
        case 'AR': return 'Argentina';
        case 'AM': return 'Armenia';
        case 'AW': return 'Aruba';
        case 'AU': return 'Australia';
        case 'AT': return 'Austria';
        case 'AZ': return 'Azerbaijan';
        case 'BS': return 'Bahamas the';
        case 'BH': return 'Bahrain';
        case 'BD': return 'Bangladesh';
        case 'BB': return 'Barbados';
        case 'BY': return 'Belarus';
        case 'BE': return 'Belgium';
        case 'BZ': return 'Belize';
        case 'BJ': return 'Benin';
        case 'BM': return 'Bermuda';
        case 'BT': return 'Bhutan';
        case 'BO': return 'Bolivia';
        case 'BA': return 'Bosnia and Herzegovina';
        case 'BW': return 'Botswana';
        case 'BV': return 'Bouvet Island (Bouvetoya)';
        case 'BR': return 'Brazil';
        case 'IO': return 'British Indian Ocean Territory (Chagos Archipelago)';
        case 'VG': return 'British Virgin Islands';
        case 'BN': return 'Brunei Darussalam';
        case 'BG': return 'Bulgaria';
        case 'BF': return 'Burkina Faso';
        case 'BI': return 'Burundi';
        case 'KH': return 'Cambodia';
        case 'CM': return 'Cameroon';
        case 'CA': return 'Canada';
        case 'CV': return 'Cape Verde';
        case 'KY': return 'Cayman Islands';
        case 'CF': return 'Central African Republic';
        case 'TD': return 'Chad';
        case 'CL': return 'Chile';
        case 'CN': return 'China';
        case 'CX': return 'Christmas Island';
        case 'CC': return 'Cocos (Keeling) Islands';
        case 'CO': return 'Colombia';
        case 'KM': return 'Comoros the';
        case 'CD': return 'Congo';
        case 'CG': return 'Congo the';
        case 'CK': return 'Cook Islands';
        case 'CR': return 'Costa Rica';
        case 'CI': return 'Cote d\'Ivoire';
        case 'HR': return 'Croatia';
        case 'CU': return 'Cuba';
        case 'CY': return 'Cyprus';
        case 'CZ': return 'Czech Republic';
        case 'DK': return 'Denmark';
        case 'DJ': return 'Djibouti';
        case 'DM': return 'Dominica';
        case 'DO': return 'Dominican Republic';
        case 'EC': return 'Ecuador';
        case 'EG': return 'Egypt';
        case 'SV': return 'El Salvador';
        case 'GQ': return 'Equatorial Guinea';
        case 'ER': return 'Eritrea';
        case 'EE': return 'Estonia';
        case 'ET': return 'Ethiopia';
        case 'FO': return 'Faroe Islands';
        case 'FK': return 'Falkland Islands (Malvinas)';
        case 'FJ': return 'Fiji the Fiji Islands';
        case 'FI': return 'Finland';
        case 'FR': return 'France, French Republic';
        case 'GF': return 'French Guiana';
        case 'PF': return 'French Polynesia';
        case 'TF': return 'French Southern Territories';
        case 'GA': return 'Gabon';
        case 'GM': return 'Gambia the';
        case 'GE': return 'Georgia';
        case 'DE': return 'Germany';
        case 'GH': return 'Ghana';
        case 'GI': return 'Gibraltar';
        case 'GR': return 'Greece';
        case 'GL': return 'Greenland';
        case 'GD': return 'Grenada';
        case 'GP': return 'Guadeloupe';
        case 'GU': return 'Guam';
        case 'GT': return 'Guatemala';
        case 'GG': return 'Guernsey';
        case 'GN': return 'Guinea';
        case 'GW': return 'Guinea-Bissau';
        case 'GY': return 'Guyana';
        case 'HT': return 'Haiti';
        case 'HM': return 'Heard Island and McDonald Islands';
        case 'VA': return 'Holy See (Vatican City State)';
        case 'HN': return 'Honduras';
        case 'HK': return 'Hong Kong';
        case 'HU': return 'Hungary';
        case 'IS': return 'Iceland';
        case 'IN': return 'India';
        case 'ID': return 'Indonesia';
        case 'IR': return 'Iran';
        case 'IQ': return 'Iraq';
        case 'IE': return 'Ireland';
        case 'IM': return 'Isle of Man';
        case 'IL': return 'Israel';
        case 'IT': return 'Italy';
        case 'JM': return 'Jamaica';
        case 'JP': return 'Japan';
        case 'JE': return 'Jersey';
        case 'JO': return 'Jordan';
        case 'KZ': return 'Kazakhstan';
        case 'KE': return 'Kenya';
        case 'KI': return 'Kiribati';
        case 'KP': return 'Korea';
        case 'KR': return 'Korea';
        case 'KW': return 'Kuwait';
        case 'KG': return 'Kyrgyz Republic';
        case 'LA': return 'Lao';
        case 'LV': return 'Latvia';
        case 'LB': return 'Lebanon';
        case 'LS': return 'Lesotho';
        case 'LR': return 'Liberia';
        case 'LY': return 'Libyan Arab Jamahiriya';
        case 'LI': return 'Liechtenstein';
        case 'LT': return 'Lithuania';
        case 'LU': return 'Luxembourg';
        case 'MO': return 'Macao';
        case 'MK': return 'Macedonia';
        case 'MG': return 'Madagascar';
        case 'MW': return 'Malawi';
        case 'MY': return 'Malaysia';
        case 'MV': return 'Maldives';
        case 'ML': return 'Mali';
        case 'MT': return 'Malta';
        case 'MH': return 'Marshall Islands';
        case 'MQ': return 'Martinique';
        case 'MR': return 'Mauritania';
        case 'MU': return 'Mauritius';
        case 'YT': return 'Mayotte';
        case 'MX': return 'Mexico';
        case 'FM': return 'Micronesia';
        case 'MD': return 'Moldova';
        case 'MC': return 'Monaco';
        case 'MN': return 'Mongolia';
        case 'ME': return 'Montenegro';
        case 'MS': return 'Montserrat';
        case 'MA': return 'Morocco';
        case 'MZ': return 'Mozambique';
        case 'MM': return 'Myanmar';
        case 'NA': return 'Namibia';
        case 'NR': return 'Nauru';
        case 'NP': return 'Nepal';
        case 'AN': return 'Netherlands Antilles';
        case 'NL': return 'Netherlands the';
        case 'NC': return 'New Caledonia';
        case 'NZ': return 'New Zealand';
        case 'NI': return 'Nicaragua';
        case 'NE': return 'Niger';
        case 'NG': return 'Nigeria';
        case 'NU': return 'Niue';
        case 'NF': return 'Norfolk Island';
        case 'MP': return 'Northern Mariana Islands';
        case 'NO': return 'Norway';
        case 'OM': return 'Oman';
        case 'PK': return 'Pakistan';
        case 'PW': return 'Palau';
        case 'PS': return 'Palestinian Territory';
        case 'PA': return 'Panama';
        case 'PG': return 'Papua New Guinea';
        case 'PY': return 'Paraguay';
        case 'PE': return 'Peru';
        case 'PH': return 'Philippines';
        case 'PN': return 'Pitcairn Islands';
        case 'PL': return 'Poland';
        case 'PT': return 'Portugal, Portuguese Republic';
        case 'PR': return 'Puerto Rico';
        case 'QA': return 'Qatar';
        case 'RE': return 'Reunion';
        case 'RO': return 'Romania';
        case 'RU': return 'Russian Federation';
        case 'RW': return 'Rwanda';
        case 'BL': return 'Saint Barthelemy';
        case 'SH': return 'Saint Helena';
        case 'KN': return 'Saint Kitts and Nevis';
        case 'LC': return 'Saint Lucia';
        case 'MF': return 'Saint Martin';
        case 'PM': return 'Saint Pierre and Miquelon';
        case 'VC': return 'Saint Vincent and the Grenadines';
        case 'WS': return 'Samoa';
        case 'SM': return 'San Marino';
        case 'ST': return 'Sao Tome and Principe';
        case 'SA': return 'Saudi Arabia';
        case 'SN': return 'Senegal';
        case 'RS': return 'Serbia';
        case 'SC': return 'Seychelles';
        case 'SL': return 'Sierra Leone';
        case 'SG': return 'Singapore';
        case 'SK': return 'Slovakia (Slovak Republic)';
        case 'SI': return 'Slovenia';
        case 'SB': return 'Solomon Islands';
        case 'SO': return 'Somalia, Somali Republic';
        case 'ZA': return 'South Africa';
        case 'GS': return 'South Georgia and the South Sandwich Islands';
        case 'ES': return 'Spain';
        case 'LK': return 'Sri Lanka';
        case 'SD': return 'Sudan';
        case 'SR': return 'Suriname';
        case 'SJ': return 'Svalbard & Jan Mayen Islands';
        case 'SZ': return 'Swaziland';
        case 'SE': return 'Sweden';
        case 'CH': return 'Switzerland, Swiss Confederation';
        case 'SY': return 'Syrian Arab Republic';
        case 'TW': return 'Taiwan';
        case 'TJ': return 'Tajikistan';
        case 'TZ': return 'Tanzania';
        case 'TH': return 'Thailand';
        case 'TL': return 'Timor-Leste';
        case 'TG': return 'Togo';
        case 'TK': return 'Tokelau';
        case 'TO': return 'Tonga';
        case 'TT': return 'Trinidad and Tobago';
        case 'TN': return 'Tunisia';
        case 'TR': return 'Turkey';
        case 'TM': return 'Turkmenistan';
        case 'TC': return 'Turks and Caicos Islands';
        case 'TV': return 'Tuvalu';
        case 'UG': return 'Uganda';
        case 'UA': return 'Ukraine';
        case 'AE': return 'United Arab Emirates';
        case 'GB': return 'United Kingdom';
        case 'US': return 'United States of America';
        case 'UM': return 'United States Minor Outlying Islands';
        case 'VI': return 'United States Virgin Islands';
        case 'UY': return 'Uruguay, Eastern Republic of';
        case 'UZ': return 'Uzbekistan';
        case 'VU': return 'Vanuatu';
        case 'VE': return 'Venezuela';
        case 'VN': return 'Vietnam';
        case 'WF': return 'Wallis and Futuna';
        case 'EH': return 'Western Sahara';
        case 'YE': return 'Yemen';
        case 'ZM': return 'Zambia';
        case 'ZW': return 'Zimbabwe';
    }
    return false;
}


function countryNameToCode($code) {
    switch ($code) {
        case 'Afghanistan': return 'AF';
        case 'Aland Islands': return 'AX';
        case 'Albania': return 'AL';
        case 'Algeria': return 'DZ';
        case 'American Samoa': return 'AS';
        case 'Andorra': return 'AD';
        case 'Angola': return 'AO';
        case 'Anguilla': return 'AI';
        case 'Antarctica': return 'AQ';
        case 'Antigua and Barbuda': return 'AG';
        case 'Argentina': return 'AR';
        case 'Armenia': return 'AM';
        case 'Aruba': return 'AW';
        case 'Australia': return 'AU';
        case 'Austria': return 'AT';
        case 'Azerbaijan': return 'AZ';
        case 'Bahamas': return 'BS';
        case 'Bahrain': return 'BH';
        case 'Bangladesh': return 'BD';
        case 'Barbados': return 'BB';
        case 'Belarus': return 'BY';
        case 'Belgium': return 'BE';
        case 'Belize': return 'BZ';
        case 'Benin': return 'BJ';
        case 'Bermuda': return 'BM';
        case 'Bhutan': return 'BT';
        case 'Bolivia': return 'BO';
        case 'Bosnia and Herzegovina': return 'BA';
        case 'Botswana': return 'BW';
        case 'Bouvet Island (Bouvetoya)': return 'BV';
        case 'Brazil': return 'BR';
        case 'British Indian Ocean Territory (Chagos Archipelago)': return 'IO';
        case 'British Virgin Islands': return 'VG';
        case 'Brunei Darussalam': return 'BN';
        case 'Bulgaria': return 'BG';
        case 'Burkina Faso': return 'BF';
        case 'Burundi': return 'BI';
        case 'Cambodia': return 'KH';
        case 'Cameroon': return 'CM';
        case 'Canada': return 'CA';
        case 'Cape Verde': return 'CV';
        case 'Cayman Islands': return 'KY';
        case 'Central African Republic': return 'CF';
        case 'Chad': return 'TD';
        case 'Chile': return 'CL';
        case 'China': return 'CN';
        case 'Christmas Island': return 'CX';
        case 'Cocos (Keeling) Islands': return 'CC';
        case 'Colombia': return 'CO';
        case 'Comoros': return 'KM';
        case 'Congo': return 'CD';
        case 'Congo the': return 'CG';
        case 'Cook Islands': return 'CK';
        case 'Costa Rica': return 'CR';
        case 'Cote d\'Ivoire': return 'CI';
        case 'Croatia': return 'HR';
        case 'Cuba': return 'CU';
        case 'Cyprus': return 'CY';
        case 'Czech Republic': return 'CZ';
        case 'Denmark': return 'DK';
        case 'Dominica': return 'DJ';
        case 'Dominica': return 'DM';
        case 'Dominican Republic': return 'DO';
        case 'Ecuador': return 'EC';
        case 'Egypt': return 'EG';
        case 'El Salvador': return 'SV';
        case 'Equatorial Guinea': return 'GQ';
        case 'Eritrea': return 'ER';
        case 'Estonia': return 'EE';
        case 'Ethiopia': return 'ET';
        case 'Faroe Islands': return 'FO';
        case 'Falkland Islands (Malvinas)': return 'FK';
        case 'Fiji the Fiji Islands': return 'FJ';
        case 'Finland': return 'FI';
        case 'France, French Republic': return 'FR';
        case 'French Guiana': return 'GF';
        case 'French Polynesia': return 'PF';
        case 'French Southern Territories': return 'TF';
        case 'Gabon': return 'GA';
        case 'Gambia': return 'GM';
        case 'Georgia': return 'GE';
        case 'Germany': return 'DE';
        case 'Ghana': return 'GH';
        case 'Gibraltar': return 'GI';
        case 'Greece': return 'GR';
        case 'Greenland': return 'GL';
        case 'Grenada': return 'GD';
        case 'Guadeloupe': return 'GP';
        case 'Guam': return 'GU';
        case 'Guatemala': return 'GT';
        case 'Guernsey': return 'GG';
        case 'Guinea': return 'GN';
        case 'Guinea-Bissau': return 'GW';
        case 'Guyana': return 'GY';
        case 'Haiti': return 'HT';
        case 'Heard Island and McDonald Islands': return 'HM';
        case 'Holy See (Vatican City State)': return 'VA';
        case 'Honduras': return 'HN';
        case 'Hong Kong': return 'HK';
        case 'Hungary': return 'HU';
        case 'Iceland': return 'IS';
        case 'India': return 'IN';
        case 'Indonesia': return 'ID';
        case 'Iran': return 'IR';
        case 'Iraq': return 'IQ';
        case 'Ireland': return 'IE';
        case 'Isle of Man': return 'IM';
        case 'Israel': return 'IL';
        case 'Italy': return 'IT';
        case 'Jamaica': return 'JM';
        case 'Japan': return 'JP';
        case 'Jersey': return 'JE';
        case 'Jordan': return 'JO';
        case 'Kazakhstan': return 'KZ';
        case 'Kenya': return 'KE';
        case 'Kiribati': return 'KI';
        case 'North Korea': return 'KP';
        case ' South Korea': return 'KR';
        case 'Kuwait': return 'KW';
        case 'Kyrgyz Republic': return 'KG';
        case 'Lao': return 'LA';
        case 'Latvia': return 'LV';
        case 'Lebanon': return 'LB';
        case 'Lesotho': return 'LS';
        case 'Liberia': return 'LR';
        case 'Libyan Arab Jamahiriya': return 'LY';
        case 'Liechtenstein': return 'LI';
        case 'Lithuania': return 'LT';
        case 'Luxembourg': return 'LU';
        case 'Macao': return 'MO';
        case 'Macedonia': return 'MK';
        case 'Madagascar': return 'MG';
        case 'Malawi': return 'MW';
        case 'Malaysia': return 'MY';
        case 'Maldives': return 'MV';
        case 'Mali': return 'ML';
        case 'Malta': return 'MT';
        case 'Marshall Islands': return 'MH';
        case 'Martinique': return 'MQ';
        case 'Mauritania': return 'MR';
        case 'Mauritius': return 'MU';
        case 'Mayotte': return 'YT';
        case 'Mexico': return 'MX';
        case 'Micronesia': return 'FM';
        case 'Moldova': return 'MD';
        case 'Monaco': return 'MC';
        case 'Mongolia': return 'MN';
        case 'Montenegro': return 'ME';
        case 'Montserrat': return 'MS';
        case 'Morocco': return 'MA';
        case 'Mozambique': return 'MZ';
        case 'Myanmar': return 'MM';
        case 'Namibia': return 'NA';
        case 'Nauru': return 'NR';
        case 'Nepal': return 'NP';
        case 'Netherlands Antilles': return 'AN';
        case 'Netherlands': return 'NL';
        case 'New Caledonia': return 'NC';
        case 'New Zealand': return 'NZ';
        case 'Nicaragua': return 'NI';
        case 'Niger': return 'NE';
        case 'Nigeria': return 'NG';
        case 'Niue': return 'NU';
        case 'Norfolk Island': return 'NF';
        case 'Northern Mariana Islands': return 'MP';
        case 'Norway': return 'NO';
        case 'Oman': return 'OM';
        case 'Pakistan': return 'PK';
        case 'Palau': return 'PW';
        case 'Palestinian Territory': return 'PS';
        case 'Panama': return 'PA';
        case 'Papua New Guinea': return 'PG';
        case 'Paraguay': return 'PY';
        case 'Peru': return 'PE';
        case 'Philippines': return 'PH';
        case 'Pitcairn Islands': return 'PN';
        case 'Poland': return 'PL';
        case 'Portugal, Portuguese Republic': return 'PT';
        case 'Puerto Rico': return 'PR';
        case 'Qatar': return 'QA';
        case 'Reunion': return 'RE';
        case 'Romania': return 'RO';
        case 'Russian Federation': return 'RU';
        case 'Rwanda': return 'RW';
        case 'Saint Barthelemy': return 'BL';
        case 'Saint Helena': return 'SH';
        case 'Saint Kitts and Nevis': return 'KN';
        case 'Saint Lucia': return 'LC';
        case 'Saint Martin': return 'MF';
        case 'Saint Pierre and Miquelon': return 'PM';
        case 'Saint Vincent and the Grenadines': return 'VC';
        case 'Samoa': return 'WS';
        case 'San Marino': return 'SM';
        case 'Sao Tome and Principe': return 'ST';
        case 'Saudi Arabia': return 'SA';
        case 'Senegal': return 'SN';
        case 'Serbia': return 'RS';
        case 'Seychelles': return 'SC';
        case 'Sierra Leone': return 'SL';
        case 'Singapore': return 'SG';
        case 'Slovakia (Slovak Republic)': return 'SK';
        case 'Slovenia': return 'SI';
        case 'Solomon Islands': return 'SB';
        case 'Somalia, Somali Republic': return 'SO';
        case 'South Africa': return 'ZA';
        case 'South Georgia and the South Sandwich Islands': return 'GS';
        case 'Spain': return 'ES';
        case 'Sri Lanka': return 'LK';
        case 'Sudan': return 'SD';
        case 'Suriname': return 'SR';
        case 'Svalbard & Jan Mayen Islands': return 'SJ';
        case 'Swaziland': return 'SZ';
        case 'Sweden': return 'SE';
        case 'Switzerland, Swiss Confederation': return 'CH';
        case 'Syrian Arab Republic': return 'SY';
        case 'Taiwan': return 'TW';
        case 'Tajikistan': return 'TJ';
        case 'Tanzania': return 'TZ';
        case 'Thailand': return 'TH';
        case 'Timor-Leste': return 'TL';
        case 'Togo': return 'TG';
        case 'Tokelau': return 'TK';
        case 'Tonga': return 'TO';
        case 'Trinidad and Tobago': return 'TT';
        case 'Tunisia': return 'TN';
        case 'Turkey': return 'TR';
        case 'Turkmenistan': return 'TM';
        case 'Turks and Caicos Islands': return 'TC';
        case 'Tuvalu': return 'TV';
        case 'Uganda': return 'UG';
        case 'Ukraine': return 'UA';
        case 'United Arab Emirates': return 'AE';
        case 'United Kingdom': return 'GB';
        case 'United States of America': return 'US';
        case 'United States Minor Outlying Islands': return 'UM';
        case 'United States Virgin Islands': return 'VI';
        case 'Uruguay, Eastern Republic of': return 'UY';
        case 'Uzbekistan': return 'UZ';
        case 'Vanuatu': return 'VU';
        case 'Venezuela': return 'VE';
        case 'Vietnam': return 'VN';
        case 'Wallis and Futuna': return 'WF';
        case 'Western Sahara': return 'EH';
        case 'Yemen': return 'YE';
        case 'Zambia': return 'ZM';
        case 'Zimbabwe': return 'ZW';
    }
    return false;
}

function wcesp_populate_country_dropdown() {

  global $wpdb;
  $countries = array();

  $query_countries = "SELECT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_billing_country' GROUP BY meta_value ORDER by meta_value ASC";

  foreach($wpdb->get_results($query_countries) as $key => $row){

   $countries[] = countryCodeToName($row->meta_value);
  }

  sort($countries);

  return $countries;



}


function wcesp_populate_categories_dropdown() {

  global $wpdb;
  $categories = array();

  $query_categories = "SELECT {$wpdb->prefix}terms.* 
  FROM {$wpdb->prefix}terms 
  LEFT JOIN {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}terms.term_id = {$wpdb->prefix}term_taxonomy.term_id
  WHERE {$wpdb->prefix}term_taxonomy.taxonomy = 'product_cat'";

  foreach($wpdb->get_results($query_categories) as $key => $row){

   $categories[] = $row;
  }

  return $categories;



}

?>