<?php 
function wcesp_generate_products_table (){

global $wpdb;

       $today = date("Y-m-d");
   if (($_GET['start_date'] && $_GET['end_date'] ) || ($_GET['start_date'] != '' && $_GET['end_date'] !='')){
    

      $start_date = sanitize_title($_GET['start_date']);
      $end_date   = sanitize_title($_GET['end_date']);
    
   }

   

   $range =  sanitize_title($_GET['range']);



       $query_stock = "SELECT order_item_meta_2.meta_value as product_id, ROUND(SUM( order_item_meta.meta_value ),2) as line_total,order_items.order_item_name as Product_name,stockmeta2.meta_value as Stock_Left,stockmeta3.meta_value AS Stock_Status, stockmeta4.meta_value as sku,COUNT(*) as sold, {$wpdb->prefix}term_relationships.*,{$wpdb->prefix}terms.*  FROM {$wpdb->prefix}woocommerce_order_items as order_items 
     
       LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta ON order_items.order_item_id = order_item_meta.order_item_id 
       LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta as order_item_meta_2 ON order_items.order_item_id = order_item_meta_2.order_item_id 
       LEFT JOIN {$wpdb->prefix}posts AS posts ON order_items.order_id = posts.ID
       LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta2 ON stockmeta2.post_id = order_item_meta_2.meta_value
       LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta3 ON stockmeta3.post_id = order_item_meta_2.meta_value
       LEFT JOIN {$wpdb->prefix}postmeta AS stockmeta4 ON stockmeta4.post_id = order_item_meta_2.meta_value
        LEFT JOIN  {$wpdb->prefix}term_relationships  ON {$wpdb->prefix}term_relationships.object_id = order_item_meta_2.meta_value
  LEFT JOIN (SELECT term_taxonomy_id as tid FROM {$wpdb->prefix}term_taxonomy WHERE taxonomy IN('product_cat')) {$wpdb->prefix}term_taxonomy ON {$wpdb->prefix}term_taxonomy.tid = {$wpdb->prefix}term_relationships.term_taxonomy_id
  LEFT JOIN {$wpdb->prefix}terms ON {$wpdb->prefix}terms.term_id = {$wpdb->prefix}term_relationships.term_taxonomy_id
       ";



  if($_GET['country'] && $_GET['country'] != 'all' && $_GET['country'] != ''){

        $query_stock .="
       LEFT JOIN {$wpdb->prefix}postmeta as country_filter ON posts.ID = country_filter.post_id 

       
       WHERE   posts.post_type   = 'shop_order' 
       AND   posts.post_status   = 'wc-completed' 
       AND   order_items.order_item_type = 'line_item' 
       AND   order_item_meta.meta_key = '_line_total' 
       AND   order_item_meta_2.meta_key = '_product_id'
       AND stockmeta2.meta_key = '_stock' AND stockmeta3.meta_key = '_stock_status'
       AND
stockmeta4.meta_key = '_sku'   AND country_filter.meta_key = '_billing_country' AND country_filter.meta_value = '{$_GET['country']}' ";
       }

       else {

          $query_stock .="
      
     
       WHERE   posts.post_type   = 'shop_order' 
       AND   posts.post_status   = 'wc-completed' 
       AND   order_items.order_item_type = 'line_item' 
       AND   order_item_meta.meta_key = '_line_total' 
       AND   order_item_meta_2.meta_key = '_product_id'
       AND stockmeta2.meta_key = '_stock' AND stockmeta3.meta_key = '_stock_status'
       AND
stockmeta4.meta_key = '_sku'  ";

       }

        if($_GET['category'] && $_GET['category'] != 'All' && $_GET['category'] != ''){

          $query_stock .= "AND term_taxonomy_id = '{$_GET['category']}'";

        
       }




          switch ($range) {
      case "custom":
         $query_stock .= " AND  date_format(posts.post_date, '%Y-%m-%d') BETWEEN '{$start_date}' AND   '{$end_date}' GROUP BY order_item_meta_2.meta_value ORDER BY line_total DESC";
         break;
      default:
         $query_stock .= "AND  date_format(posts.post_date, '%Y-%m-%d') BETWEEN '{$today}' AND   '{$today}' GROUP BY order_item_meta_2.meta_value ORDER BY line_total DESC";
   }

  
 

     

   



         foreach ($wpdb->get_results($query_stock) as $key => $row) {
         
      $pro = $row->product_id;
      $cat = "SELECT wp_terms.name FROM wp_term_relationships
  LEFT JOIN wp_posts  ON wp_term_relationships.object_id = wp_posts.ID
  LEFT JOIN wp_term_taxonomy ON wp_term_taxonomy.term_taxonomy_id = wp_term_relationships.term_taxonomy_id
  LEFT JOIN wp_terms ON wp_terms.term_id = wp_term_relationships.term_taxonomy_id
  WHERE post_type = 'product' AND taxonomy = 'product_cat' 
  AND  object_id = '{$pro}'";
  

    $categories = $wpdb->get_var($cat);
      $product[] = $row->Product_name;
       if($categories == '')
       {
        $category[] = "-";
       }
       else {

         $category[]= $categories;
       }
       $pro_id[] = $row->product_id;
       $sku[] = $row->sku;
       if($row->Stock_Status == 'instock'){
         $s_status[] = "In Stock";
       }
       else {
           $s_status[] = "Out of Stock";
       }
      
       $sold[] = $row->sold;
       $sales[] = "$".$row->line_total;
       $left[] = $row->Stock_Left;
     
      
    
      
   }

 



  
   $armcharts_image_path = plugins_url('/armcharts_images', __FILE__);
   $trials = wcesp_product_type(); 


?>
 <div class="col-md-1 config-holder">
                <a id="menu-toggle" href="#" class="btn btn-primary btn-lg toggle filter_icon"><i class="glyphicon glyphicon-menu-hamburger"></i></a>
                <div id="sidebar-wrapper">
                   <ul class="sidebar-nav">
                        <a id="menu-close" href="#" class="btn btn-default btn-lg pull-right toggle"><i class="glyphicon glyphicon-remove filter_close"></i></a>
                        <li class="sidebar-brand">
                            <a href="#">Filters</a>
                        </li>
                        <li>
                           
                            <?php $status_check= wcesp_status_check(); if (($status_check[ 'activated']=="active" && $trials['type'] == 1) || ($status_check[ 'check']=="active" && $trials['type'] == 1)  ) { ?>
                            <form method="GET" class="date_range_form">
                                <div class="form-group custom_form_group">
                                    <!-- Date input -->
                                    <label class="control-label woochart_label_activated" for="date">Select Date Range</label>
                                </div>
                                <div class="form-group custom_form_group">
                                    <div id="reportrange" class="reports">
                                        <i class="glyphicon glyphicon-calendar fa fa-calendar filter_form"></i>&nbsp;
                                        <span><?php
                                                if ($_GET['start_date'] && $_GET['end_date']) {
                                                      echo $_GET['start_date'] . ' - ' . $_GET['end_date'];
                                                  } else {
                                                      echo "Today";
                                                  }
                                        ?></span>
                                    </div>
                                    <input class="form-control" id="end_date" name="end_date" placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['end_date']; ?>" />
                                    <input class="form-control" id="start_date" name="start_date" placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['start_date']; ?>" />
                                    <input type="hidden" name="page" value="WooCharts-Products" />
                                    <input type="hidden" name="range" value="custom" />
                                    <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Category</label>
                                    </div>
                                    <select name="category" class="pfilter" id="c_filter">
                                        <option value="">SELECT</option>
                                        <option value="All">All</option>
                                        <?php  
                                         $categories_filter = wcesp_populate_categories_dropdown();
                                         foreach ($categories_filter as $key => $value) { ?>
                                        <option value="<?php echo $value->term_id; ?>">
                                            <?php echo $value->name; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Country</label>
                                    </div>
                                    <select name="country" class="pfilter" id="c_filter">
                                        <option value="">SELECT</option>
                                        <option value="all">All</option>
                                        <?php  
                                        $countries_filter = wcesp_populate_country_dropdown();
                              
                                         foreach ($countries_filter as $key => $value) { ?>
                                        <option value="<?php echo countryNameToCode($value); ?>">
                                            <?php echo $value; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <br/>
                                    <button class="btn btn-primary " name="submit" type="submit" id="submit_custom">Submit</button>
                                </div>
                            </form>
                            <?php } elseif(($status_check[ 'activated']=="active" && $trials['type'] == 2) || ($status_check[ 'check']=="active" && $trials['type'] == 2)){ ?>
                       <form method="GET" class="date_range_form">
                            <div class="form-group custom_form_group" id="one-one">

                         <div class="form-group custom_form_group">
                        <!-- Date input -->
                        <label class="control-label woochart_label_activated for_date" for="date">Select Date Range - <span class="pro_text">PRO</span></label>
                         </div>
                       
                        <div id="reportrange" class="reports">
                            <i class="glyphicon glyphicon-calendar fa fa-calendar filter_form"></i>&nbsp;
                            <span><?php
                        if ($_GET['start_date'] && $_GET['end_date']) {
                            echo $_GET['start_date'] . ' - ' . $_GET['end_date'];
                        } else {
                            echo "Today";
                        }
                        ?></span>
                        </div>
                         <input disabled class="form-control" id="end_date"  placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['end_date']; ?>" />
                                    <input disabled class="form-control" id="start_date"  placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['start_date']; ?>" />
                        <input type="hidden" name="page" value="WooCharts-Products" />
                        <input type="hidden" name="range" value="custom" />
                        
                         <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Category - <span class="pro_text">PRO</span></label>
                                    </div>
                                    <select  class="pfilter" id="c_filter" disabled>
                                        <option value="">SELECT</option>
                                        <option value="All">All</option>
                                        <?php  
                                         $categories_filter = wcesp_populate_categories_dropdown();
                                         foreach ($categories_filter as $key => $value) { ?>
                                        <option value="<?php echo $value->term_id; ?>">
                                            <?php echo $value->name; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Country - <span class="pro_text">PRO</span></label>
                                    </div>
                                    <select  class="pfilter" id="c_filter" disabled>
                                        <option value="">SELECT</option>
                                        <option value="all">All</option>
                                        <?php  
                                        $countries_filter = wcesp_populate_country_dropdown();
                              
                                         foreach ($countries_filter as $key => $value) { ?>
                                        <option value="<?php echo countryNameToCode($value); ?>">
                                            <?php echo $value; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <br/>
                        <button class="btn btn-primary" id="submit_custom">Submit</button>
                        <br/>
                    </div>
                </form>
                <br/>
                <!-- 
                     <input class="form-control" id="end_date" name="end_date" placeholder="MM/DD/YYY" type="hidden"/>
                     </div>
                     <div class="form-group custom_form_group"> 
                      -->
                <?php }  else{ ?>
                       <form method="GET" class="date_range_form">
                            <div class="form-group custom_form_group" id="one-one">

                         <div class="form-group custom_form_group">
                        <!-- Date input -->
                        <label class="control-label woochart_label_activated for_date" for="date">Select Date Range - <span class="pro_text">PRO</span></label>
                         </div>
                       
                        <div id="reportrange" class="reports">
                            <i class="glyphicon glyphicon-calendar fa fa-calendar filter_form"></i>&nbsp;
                            <span><?php
                        if ($_GET['start_date'] && $_GET['end_date']) {
                            echo $_GET['start_date'] . ' - ' . $_GET['end_date'];
                        } else {
                            echo "Today";
                        }
                        ?></span>
                        </div>
                         <input disabled class="form-control" id="end_date"  placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['end_date']; ?>" />
                                    <input disabled class="form-control" id="start_date"  placeholder="MM/DD/YYY" type="hidden" value="<?php echo $_GET['start_date']; ?>" />
                        <input type="hidden" name="page" value="WooCharts-Products" />
                        <input type="hidden" name="range" value="custom" />
                        
                         <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Category - <span class="pro_text">PRO</span></label>
                                    </div>
                                    <select  class="pfilter" id="c_filter" disabled>
                                        <option value="">SELECT</option>
                                        <option value="All">All</option>
                                        <?php  
                                         $categories_filter = wcesp_populate_categories_dropdown();
                                         foreach ($categories_filter as $key => $value) { ?>
                                        <option value="<?php echo $value->term_id; ?>">
                                            <?php echo $value->name; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <div class="form-group custom_form_group">
                                        <!-- Date input -->
                                        <label class="control-label woochart_label_activated" for="date">Select Country - <span class="pro_text">PRO</span></label>
                                    </div>
                                    <select  class="pfilter" id="c_filter" disabled>
                                        <option value="">SELECT</option>
                                        <option value="all">All</option>
                                        <?php  
                                        $countries_filter = wcesp_populate_country_dropdown();
                              
                                         foreach ($countries_filter as $key => $value) { ?>
                                        <option value="<?php echo countryNameToCode($value); ?>">
                                            <?php echo $value; ?>
                                        </option>
                                        <?php    }   ?>
                                    </select>
                                    <br/>
                        <button class="btn btn-primary" id="submit_custom" onclick="unlockPRO();">Submit</button>
                        <br/>
                    </div>
                </form>
                <br/>
                <!-- 
                     <input class="form-control" id="end_date" name="end_date" placeholder="MM/DD/YYY" type="hidden"/>
                     </div>
                     <div class="form-group custom_form_group"> 
                      -->
                <?php }  ?>
              
                </li>
                </ul>
            </div>
        </div>
<div class="charts" style="display:inline-block; width: 100%">
  
    
      <?php   $status_check= wcesp_status_check(); if (($status_check[ 'activated']=="active" && $trials['type'] == 1) || ($status_check[ 'check']=="active" && $trials['type'] == 1)) { ?>
      <div class="chart-container nine" style="min-height: 75px !important;">
       <table id="product_stock" class="display stripe" width="100%">
 
    <thead><tr>
    <th>ID</th>
                    <th>Product Name</th>
                    <th>Category</th>
                    <th>SKU</th>
                    <th>Stock Status</th>
                    <th>Units Sold</th>
                    <th>Total Sales</th>

                    <th>Stock Left</th></tr>

</thead>
<tbody>

  <?php if($product){foreach ($product as $key => $value) { ?>
   
   <tr>
     <td><?php echo $pro_id[$key]; ?></td>
    <td><?php echo $value; ?></td>
    <td><?php echo $category[$key]; ?></td>
     <td><?php echo $sku[$key]; ?></td>
      <td><?php echo $s_status[$key]; ?></td>
       <td><?php echo $sold[$key]; ?></td>
       <td><?php echo $sales[$key]; ?></td>

        <td><?php echo $left[$key]; ?></td>

   
 

    
  </tr>

 <?php } }  ?>
</tbody>
</table>
</div>
<?php } else{ ?>
 <div class="chart-container nine"> <center><h3 class="table_info">See What the Pro Version can do for you</h3><a href="https://www.essentialplugins.com/wordpress/woo-charts-pricing?utm_source=p&utm_medium=w&utm_campaign=t" class="pro_link buy_pro" target="_blank">BUY PRO VERSION</a>
                <br/><br/><h3 class="table_info">WooCommerce Stock & Sales Report</h3><br/><br/>
               <span class="pro_box"><i class="glyphicon glyphicon-table fa fa-table pro_icons"></i><p class="table_info"> Need a complete Stock & Sale Report? This table lets the user have a complete detailed tabular report that shows the sales for any date range and current stock levels.</p><br/><br/>
              <img src = "<?php echo $armcharts_image_path.'/tables.png'; ?>" alt="products table"></span><br/><br/>

              <br/><br/>
                <span class="pro_box"><i class="glyphicon glyphicon-table fa fa-filter pro_icons"></i><p class="table_info"> Looking for a specific report? Narrow down your search report by using filters to filter down by Date Range, Product Category and Country.</p><br/><br/>
                 <img src = "<?php echo $armcharts_image_path.'/filters.png'; ?>" alt="filters table"></span><br/><br/>
           
             
           </center></div>
             


            <?php } ?>


        
    </div>


<script>
   function unlockPRO() {
        alert("Please activate Woo Charts to enable this feature!");
        // window.location ='https://www.google.com';
    }
    jQuery("#sidebar-wrapper").addClass("active");
    
    jQuery("#menu-close").click(function(e) {
        e.preventDefault();
        jQuery("#sidebar-wrapper").toggleClass("active");
    });

    jQuery("#menu-toggle").click(function(e) {
        e.preventDefault();
        jQuery("#sidebar-wrapper").toggleClass("active");

    });
 </script>
 <script>
     var startDate;
    var endDate;





    jQuery('#reportrange').daterangepicker({

            <?php if(!$_GET['start_date']){
          ?>

            startDate: moment(),
            endDate: moment(),
            <?php  }

        else { ?>

            startDate: '<?php echo date("m/d/Y", strtotime($_GET["start_date"])); ?>',
            endDate: '<?php echo date("m/d/Y", strtotime($_GET["end_date"])); ?>',

            <?php } ?>


            autoUpdateInput: true,
            autoApply: true,
            ranges: {
                'Today': [moment(), moment()],
                'Yesterday': [moment().subtract('days', 1), moment().subtract('days', 1)],
                'Last 7 Days': [moment().subtract('days', 6), moment()],
                'Last 30 Days': [moment().subtract('days', 29), moment()],
                'This Month': [moment().startOf('month'), moment().endOf('month')],
                'Last Month': [moment().subtract('month', 1).startOf('month'), moment().subtract('month', 1).endOf('month')]
            },

            format: 'YYYY-MM-DD',
            separator: ' to ',

        },
        function(start, end) {
            console.log("Callback has been called!");

            startDate = start;
            endDate = end;
            jQuery('#reportrange span').html(startDate.format('YYYY-MM-DD') + ' - ' + endDate.format('YYYY-MM-DD'));
            jQuery('#reportrange').val(startDate.format('YYYY-MM-DD'));


        }
    );

    //Set the initial state of the picker label


    jQuery('#submit_custom').click(function() {
        jQuery('#reportrange span').html(startDate.format('YYYY-MM-DD') + ' - ' + endDate.format('YYYY-MM-DD'));
        document.getElementById('start_date').value = startDate.format('YYYY-MM-DD');
        document.getElementById('end_date').value = endDate.format('YYYY-MM-DD');
    });
 </script>
 <script>
  var $ = jQuery;

 
$('#product_stock').DataTable({
        "sDom": '<"top"if>rt<"bottom1"pl><"clear">',
    
    "order": [
        [1, "desc"]
    ]
});


      </script>

 <?php } 
 ?>