<?php
function wcesp_settings_forms_status(){
    
    global $wpdb;
   
    $key = $wpdb->get_var("SELECT woochart_key FROM {$wpdb->prefix}woochart_data");
    if (!$key) {
        $status_code = 0;
        return $status_code;
    } else {
        $status_code = wcesp_status_check();

        if($status_code['check'] == "active" || $status_code['activated'] == "active"){
          
           return $status_code;
        }
        else {
            $status_code = 1;
              return $status_code;
        }

    }




}

function wcesp_settings_forms_generate(){

    global $wpdb;

    $status_code = wcesp_settings_forms_status();
    if($status_code == 0){

        $array = wcesp_new_activation();
    }
    elseif($status_code == 1) {

          wcesp_deactivated_form();

    }

    else{

        wcesp_activated_form($status_code);
    }

}

function wcesp_activated_form($status_code){
    global $wpdb;

    if(isset($_POST['Activate-Over'])){
        $msg = "";

        $data  = array();
        $query = "SELECT * FROM {$wpdb->prefix}woochart_data";
        foreach ($wpdb->get_results($query) as $key => $row) {
        $data = $row;
         } 

        $type = sanitize_text_field($_POST['type']);
        $characters = 'abcdefghijklmnrstuvwxyz0123456789';
        $string = '';
        $max = strlen($characters) - 1;
        for ($i = 0; $i < 10; $i++) {
        $string .= $characters[mt_rand(0, $max)];
        }
     
            $instance = $string;
        

              $email = sanitize_email($_POST['email']);
       $wookey = sanitize_text_field($_POST['woochart_key']);
       $product = "Woo Charts";
       if($type == 1){
        $product = "Woo Charts Pro";
       }
$body = array(
    'wc-api' => 'am-software-api',
    'email' => $email,
    'licence_key' => $wookey,
    'request' => 'activation',
    'product_id' => $product,
    'instance' => $instance,
    'platform' => $_SERVER["SERVER_NAME"]
);
 
$args = array(
    'body' => $body
    
);

$response = wp_remote_post( 'https://www.essentialplugins.com', $args );
if (is_array($response) && !empty($response['body'])) {
  $array = json_decode($response['body']);
   
}

      if($array->error){

        $msg = "Activation Error:- You Have Provided an Invalid License Key/Email Address";
       
      }

      else {

        $msg = "";
      }
        if ($array->activated == "true") {

           
            $one = 1;
            global $wpdb;
            $table_name = $wpdb->prefix . 'woochart_data';
           
           $wpdb->query("UPDATE $table_name SET email = '$email',woochart_key = '$wookey', type = '$type', instance = '$instance' WHERE 1");
            wcesp_settings_forms_generate();
             $msg = "WooChart Activated successfuly";
            exit;
        }
    }

    
    ?>
    <section class="container">
        <h1 class="t_header">WooCharts Account Details</h1>
        <div class="left-half col-md-6">
            <div id="woochart_activation_form" class="woochart_activation_form">
                <h1 class="t_form">Please enter valid E-mail & License key to activate WooCharts</h1>
                <form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>" id="woochart_settings_form">
                    <input type="email" placeholder="Enter your E-mail" name="email" />
                    <input type="text" placeholder="Enter you WooCharts License Key" name="woochart_key" />
                    <select name="type" class="typeform">
                        <option value="1">Woo Charts Pro</option>
                        <option value="2">Woo Charts </option>
                    </select>
                    <input type="submit" name="Activate-Over" value="Activate" />
                </form>
               
            </div>
        </div>
        <div class="right-half col-md-6">
            <div id="woochart_activation" class="woochart_activation">
                <table style="padding:20px;">
                    <tbody>
                        <tr>
                            <th>Current Status:</th>
                            <td>
                                <font color="green" ;>Activated <img src="<?php echo plugins_url('../assets/images/activated.png', __FILE__); ?>"></font>
                            </td>
                        </tr>
                        <tr>
                            <th>E-mail:</th>
                            <td>
                                <?php  echo $status_code['data']['license_email']; ?>
                            </td>
                        </tr>
                        <tr>
                            <th>Product:</th>
                            <td>
                                <?php  echo $status_code['data']['product_id']; ?>
                            </td>
                        </tr>
                        <tr>
                            <th>License Key:</th>
                            <td colspan="2">
                                <?php echo substr_replace($status_code['data']['order_key'], '*********', 6 , 13); ?>
                            </td>
                        </tr>
                        <tr>
                            <th>Activations Remaining:</th>
                            <td colspan="2">
                                <?php  $a = $status_code['data']['activations_remaining']; $s = $a[0]; echo $s.' activations remaining' ;  ?>
                            </td>
                        </tr>
                        <tr>
                            <th>License Key Activated On:</th>
                            <td colspan="2">
                                <?php  echo date("M jS Y", strtotime($status_code['data']['activation_time'])); ?>
                            </td>
                        </tr>
                        <tr>
                            <th>License Key Purchased on:</th>
                            <td colspan="2">
                                <?php  echo date("M jS Y", strtotime($status_code['data']['purchase_time'])); ?>
                            </td>
                        </tr>
                        <tr>
                            <th>Current Plugin Version:</th>
                            <td colspan="2">
                                <?php  echo $status_code['data']['current_version']; ?>
                            </td>
                        </tr>
                        <?php 
                    if($status_code['data']['product_id'] == "Woo Charts") {  ?>
                        <tr>
                            <th> <a href="https://www.essentialplugins.com/contact-us/" class="pro_link contact-us" target="_blank">Contact Us</a></th>
                            
                        </tr>
                        <?php  } 

                        else {  ?>
                        <tr>
                            <th> <a href="https://www.essentialplugins.com/contact-us/" class="pro_link contact-us" target="_blank">Contact Us</a></th>
                        </tr>
                        <?php } 


                        ?>
                    </tbody>
                </table>
            </div>
        </div>
    </section>
    <?php 
                    if($status_code['data']['product_id'] == "Woo Charts") {  ?>
    <div class="col-md-12">
        <div class="chart-container nine"> <center><h3 class="table_info">See What the Pro Version can do for you</h3><a href="https://www.essentialplugins.com/wordpress/woo-charts-pricing?utm_source=p&utm_medium=w&utm_campaign=t" class="pro_link buy_pro" target="_blank">BUY PRO VERSION</a>
              
               <span class="pro_box"><br/>
              <img src = "http://essentialplugins.com/wp-content/uploads/2017/11/compare.png" alt="products table"></span><br/><br/>
           </center>
       </div>
        </div>

    <?php }
}

function wcesp_deactivated_form(){
    $msg = "";
        
        global $wpdb;
        $data  = array();
        $query = "SELECT * FROM {$wpdb->prefix}woochart_data";
        foreach ($wpdb->get_results($query) as $key => $row) {
        $data = $row;
        }

        if (isset($_POST['Activate-Again'])) {
        
        $characters = 'abcdefghijklmnrstuvwxyz0123456789';
        $string = '';
        $max = strlen($characters) - 1;
         for ($i = 0; $i < 10; $i++) {
        $string .= $characters[mt_rand(0, $max)];
        }

        

            $instance = $string;
        
       $type = sanitize_text_field($_POST['type']);
       $product = "Woo Charts";
       if($type == 1){
        $product = "Woo Charts Pro";
       }
       $msg_success = "";
       $email = sanitize_email($_POST['email']);
       $wookey = sanitize_text_field($_POST['woochart_key']);
    
$body = array(
    'wc-api' => 'am-software-api',
    'email' => $email,
    'licence_key' => $wookey,
    'request' => 'activation',
    'product_id' => $product,
    'instance' => $instance,
    'platform' => $_SERVER["SERVER_NAME"]
);
 
$args = array(
    'body' => $body
    
);

$response = wp_remote_post( 'https://www.essentialplugins.com', $args );

if (is_array($response) && !empty($response['body'])) {
  $array = json_decode($response['body']);
   
}


        if ($array->error) {
            if ($array->error == "Software API error" && $array->activated == "inactive") {
               
                $msg= "Your License Key has been DEACTIVATED. Please contact support.";
            }
            else {

                $msg = "Invalid Request.Please Enter a Valid License Key/Email to Activate WooCharts";
            }
        }
        else {

                  $email = sanitize_email($_POST['email']);
       $wookey = sanitize_text_field($_POST['woochart_key']);
   
            $table_name = $wpdb->prefix . 'woochart_data';
           
           $wpdb->query("UPDATE $table_name SET email = '$email',woochart_key = '$wookey', type = '$type', instance = '$instance' WHERE 1");
           
            $msg = "WooChart Activated successfuly";
            $one = 1;

            wcesp_settings_forms_generate();
            exit;
        }
   
    }
    ?>
        <section class="container">
            <h1 class="t_header">WooCharts Account Details</h1>
            <div class="left-half col-md-6">
                <div id="woochart_activation_form" class="woochart_activation_form">
                    <h1 class="t_form">Please enter valid E-mail & License key to activate WooCharts</h1>
                    <form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>" id="woochart_settings_form">
                        <input type="email" placeholder="Enter your E-mail" name="email" />
                        <input type="text" placeholder="Enter you WooCharts License Key" name="woochart_key" />
                        <select name="type" class="typeform">
                            <option value="1">Woo Charts Pro</option>
                            <option value="2">Woo Charts </option>
                        </select>
                        <input type="submit" name="Activate-Again" value="Activate" />
                    </form>
                  
                </div>
            </div>
            <div class="right-half col-md-6">
                <div id="woochart_activation" class="woochart_activation">
                    <table style="padding: 20px;">
                        <tbody>
                            <tr>
                                <th>Current Status:</th>
                                <td colspan="2" align="left">
                                    <font color="red" ;>Deactivated <img src="<?php echo plugins_url('../assets/images/deactivated.png', __FILE__); ?>"></font>
                                </td>
                            </tr>
                            <tr>
                                <th>E-mail:</th>
                                <td colspan="2" align="left">
                                    <?php  echo $data->email; ?>
                                </td>
                            </tr>
                            <tr>
                                <th>License Key:</th>
                                <td colspan="2" align="left">
                                    <?php echo substr_replace($data->woochart_key, '*********', 6 , 13); ?>
                                </td>
                            </tr>
                            <tr>
                                <th>Activations Remaining:</th>
                                <td colspan="2" align="center">--</td>
                            </tr>
                            <tr>
                                <th>License Key Activated On:</th>
                                <td colspan="2" align="center">--</td>
                            </tr>
                            <tr>
                                <th>License Key Purchased on:</th>
                                <td colspan="2" align="center">--</td>
                            </tr>
                            <tr>
                                <th>Current Plugin Version:</th>
                                <td colspan="2" align="center">--</td>
                            </tr>
                            <tr>
                                <th> <a href="https://www.essentialplugins.com/contact-us/" class="pro_link contact-us" target="_blank">Contact Us</a></th>
                               
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </section>
        <div class="col-md-12">
        <div class="chart-container nine"> <center><h3 class="table_info">See What the Pro Version can do for you</h3><a href="https://www.essentialplugins.com/wordpress/woo-charts-pricing?utm_source=p&utm_medium=w&utm_campaign=t" class="pro_link buy_pro" target="_blank">BUY PRO VERSION</a>
               
               <span class="pro_box"><br/>
              <img src = "http://essentialplugins.com/wp-content/uploads/2017/11/compare.png" alt="products table"></span><br/><br/>
           </center>
       </div>
        </div>
        <?php
}

function wcesp_status_check()
{
    global $wpdb;
    $data  = array();
    $query = "SELECT * FROM {$wpdb->prefix}woochart_data";
    foreach ($wpdb->get_results($query) as $key => $row) {
        $data = $row;
    }
       $type = $data->type;
       $product = "Woo Charts";
       if($type == 1){
        $product = "Woo Charts Pro";
       }
$body = array(
    'wc-api' => 'am-software-api',
    'email' => $data->email,
    'licence_key' => $data->woochart_key,
    'request' => 'status',
    'product_id' => $product,
    'instance' => $data->instance,
    'platform' => $_SERVER["SERVER_NAME"]
);
 
$args = array(
    'body' => $body
    
);

$response = wp_remote_post( 'https://www.essentialplugins.com', $args );

if (is_array($response) && !empty($response['body'])) {
  $array = json_decode($response['body']);
   
}


    
    //Output to check
 
    $status_check              = array();
    $status_check['check']     = $array->status_check;
    $status_check['activated'] = $array->activated;
     $status_check['data']['product_id'] = $array->status_extra->product_id;
    $status_check['data']['license_email'] = $array->data_extra->license_email;
    $status_check['data']['order_key'] = $array->status_extra->order_key;
    
    $status_check['data']['purchase_time'] = $array->data_extra->_purchase_time;
    $status_check['data']['activation_time'] = $array->status_extra->activation_time;
    $status_check['data']['activations_remaining'] = $array->activations_remaining;

    $status_check['data']['current_version'] = $array->data_extra->current_version;
    return $status_check;

}

function wcesp_product_type(){

    global $wpdb;
    $data  = array();
    $query = "SELECT * FROM {$wpdb->prefix}woochart_data";
    foreach ($wpdb->get_results($query) as $key => $row) {
        $data = $row;
    }

        
       $_array = array(); 
       
       $_array['type'] = $data->type;
       $_array['expiry'] = $data->expiry;

       return $_array;

}

function wcesp_new_activation()
{

    global $wpdb;
    $msg = "";
    if (isset($_POST['Activate'])) {
        $msg_success = "";
        $type = sanitize_text_field($_POST['type']);
        $characters = 'abcdefghijklmnrstuvwxyz0123456789';
        $string = '';
 $max = strlen($characters) - 1;
 for ($i = 0; $i < 10; $i++) {
      $string .= $characters[mt_rand(0, $max)];
 }

 $instance = $string;
              $email = sanitize_email($_POST['email']);
       $wookey = sanitize_text_field($_POST['woochart_key']);
       $product = "Woo Charts";
       if($type == 1){
        $product = "Woo Charts Pro";
       }
        $body = array(
    'wc-api' => 'am-software-api',
    'email' => $email,
    'licence_key' => $wookey,
    'request' => 'activation',
    'product_id' => $product,
    'instance' => $instance,
    'platform' => $_SERVER["SERVER_NAME"]
);
 
$args = array(
    'body' => $body
    
);

$response = wp_remote_post( 'https://www.essentialplugins.com', $args );

if (is_array($response) && !empty($response['body'])) {
  $array = json_decode($response['body']);
   
}

      if($array->error){

        $msg = "Activation Error:- You Have Provided an Invalid License Key/Email Address";
       
      }
        if (!$array->error && $array->activated == "true") {
            $msg = "WooChart Activated successfuly";
            $one = 1;
            global $wpdb;
            $date = strtotime("+7 day");
            $expiry = $date;
            $table_name = $wpdb->prefix . 'woochart_data';
            $wpdb->insert("$table_name", //table
                array(
                'email' => $email,
                'woochart_key' => $wookey,
                'instance' => $instance,
                'type' => $type,
                'expiry' => $expiry
            ), //data
                array(
                '%s',
                '%s',
                '%s',
                '%d',
                '%s'
            ) //data format
                );
            wcesp_settings_forms_generate();
            exit;
        }
      

        
    }
?>
            <section class="container">
                <div class="right-half active_left" style="width: 50%; display:block;">
                    <span class="t_header">WooCharts Account Details</span>
                    <div id="woochart_activation_form" class="woochart_activation_form">
                        <h1 class="t_form">Please enter your E-mail & License key to activate WooCharts</h1>
                        <form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>" id="woochart_settings_form" class="new_settings">
                            <input type="email" placeholder="Enter your E-mail" name="email" />
                            <input type="text" placeholder="Enter you WooCharts License Key" name="woochart_key" />
                            <select name="type" class="typeform">
                                <option value="1">Woo Charts Pro</option>
                                <option value="2">Woo Charts </option>
                            </select>
                            <input type="submit" name="Activate" value="Activate" />
                        </form>
                        
                    </div>
                </div>
            </section>
            <?php
}


?>